//+------------------------------------------------------------------+
//|                                          Ind - BarSearch.mq4.mq5 |
//|                                Copyright 2008-2015, Expforex.com |
//|                                          http://www.expforex.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2008-2015, Expforex.com"
#property link      "http://www.expforex.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 2
//--- plot UP
#property indicator_label1  "UP"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrSpringGreen
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot DN
#property indicator_label2  "DN"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- input parameters
input int      High_Shadow_Min=30;
input int      High_Shadow_Max=5000;
input int      Low_Shadow_Min=30;
input int      Low_Shadow_Max=5000;
input int      Body_Min=50;
input int      Body_Max=6000;
//--- indicator buffers
double         UPBuffer[];
double         DNBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {

   SetIndexBuffer(0,UPBuffer);
   SetIndexBuffer(1,DNBuffer);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
string comentlast10Candles="\n\n Last 10 Bars ";
int kol=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---

   int limit=rates_total-prev_calculated;
//---
//---


   if(prev_calculated>0)
      limit++;
   for(int i=0; i<limit; i++)
     {
      if(Open[i]<Close[i])
        {
         if(High[i]-Close[i]<=High_Shadow_Max*Point)
            if(High[i]-Close[i]>=High_Shadow_Min*Point)
               if(Open[i]-Low[i]<=Low_Shadow_Max*Point)
                  if(Open[i]-Low[i]>=Low_Shadow_Min*Point)
                     if(Close[i]-Open[i]>=Body_Min*Point)
                        if(Close[i]-Open[i]<=Body_Max*Point)
                          {
                           UPBuffer[i]=Low[i];
                           if(kol<10)comentlast10Candles=comentlast10Candles+"\n"
                              +"UP BAR i="+i
                              +" High="+(High[i]-Close[i])/Point
                              +" Low="+(Open[i]-Low[i])/Point
                              +" Close="+(Close[i]-Open[i])/Point
                              ;
                           kol++;
                          }

        }

      if(Open[i]>Close[i])
        {
         if(High[i]-Open[i]<=High_Shadow_Max*Point)
            if(High[i]-Open[i]>=High_Shadow_Min*Point)
               if(Close[i]-Low[i]<=Low_Shadow_Max*Point)
                  if(Close[i]-Low[i]>=Low_Shadow_Min*Point)
                     if(Open[i]-Close[i]>=Body_Min*Point)
                        if(Open[i]-Close[i]<=Body_Max*Point)
                          {
                           DNBuffer[i]=Low[i];
                           if(kol<10)comentlast10Candles=comentlast10Candles+"\n"
                              +"DN BAR i="+i
                              +" High="+(High[i]-Open[i])/Point
                              +" Low="+(Close[i]-Low[i])/Point
                              +" Open="+(Open[i]-Close[i])/Point
                              ;
                           kol++;
                          }
        }
     }

   Comment(comentlast10Candles+kol);

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
